> For the complete documentation index, see [llms.txt](https://docs.quilt.bio/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.quilt.bio/version-3.1.13/api-reference/api.md).

# quilt3

Quilt API

## config(\*catalog\_url, \*\*config\_values) <a href="#config" id="config"></a>

Set or read the QUILT configuration.

To retrieve the current config, call directly, without arguments:

```python
    >>> import quilt3
    >>> quilt3.config()
```

To trigger autoconfiguration, call with just the navigator URL:

```python
    >>> quilt3.config('https://example.com')
```

To set config values, call with one or more key=value pairs:

```python
    >>> quilt3.config(navigator_url='http://example.com',
    ...               elastic_search_url='http://example.com/queries')
```

Default config values can be found in `quilt3.util.CONFIG_TEMPLATE`.

**Arguments**

* **catalog\_url**:  A (single) URL indicating a location to configure from
* **\*\*config\_values**:  `key=value` pairs to set in the config

**Returns**

`QuiltConfig`: (an ordered Mapping)

## delete\_package(name, registry=None, top\_hash=None) <a href="#delete-_package" id="delete-_package"></a>

Delete a package. Deletes only the manifest entries and not the underlying files.

**Arguments**

* **name (str)**:  Name of the package
* **registry (str)**:  The registry the package will be removed from
* **top\_hash (str)**:  Optional. A package hash to delete, instead of the whole package.

## list\_package\_versions(name, registry=None) <a href="#list-_package-_versions" id="list-_package-_versions"></a>

Lists versions of a given package.

Returns a sequence of (version, hash) of a package in a registry. If the registry is None, default to the local registry.

**Arguments**

* **registry(string)**:  location of registry to load package from.

**Returns**

A sequence of tuples containing the named version and hash.

## list\_packages(registry=None) <a href="#list-_packages" id="list-_packages"></a>

Lists Packages in the registry.

Returns a sequence of all named packages in a registry. If the registry is None, default to the local registry.

**Arguments**

* **registry(string)**:  location of registry to load package from.

**Returns**

A sequence of strings containing the names of the packages

## login() <a href="#login" id="login"></a>

Authenticate to your Quilt stack and assume the role assigned to you by your stack administrator. Not required if you have existing AWS credentials.

Launches a web browser and asks the user for a token.

## logout() <a href="#logout" id="logout"></a>

Do not use Quilt credentials. Useful if you have existing AWS credentials.

## search(query, limit=10) <a href="#search" id="search"></a>

Execute a search against the configured search endpoint.

**Arguments**

* **query (str)**:  query string to search
* **limit (number)**:  maximum number of results to return. Defaults to 10

Query Syntax: [simple query string query](https://www.elastic.co/guide/en/elasticsearch/reference/6.8/query-dsl-simple-query-string-query.html)

**Returns**

a list of objects with the following structure:

```
[{
`"_id"`: <document unique id>
`"_index"`: <source index>,
`"_score"`: <relevance score>
    "_source":
`"key"`: <key of the object>,
`"size"`: <size of object in bytes>,
`"user_meta"`: <user metadata from meta= via quilt3>,
`"last_modified"`: <timestamp from ElasticSearch>,
`"updated"`: <object timestamp from S3>,
`"version_id"`: <version_id of object version>
`"_type"`: <document type>
}, ...]
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.quilt.bio/version-3.1.13/api-reference/api.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
